// Step 2: Create list of unique country codes in the data

* 0) Preliminaries
*** Cleaning
	clear
	cls
	set more off
	set rmsg on																	// Keeps track of length of process
	
*** Install codes
   ssc install fs
   ssc install confirmdir
   ssc install chunky
   
*** Directories
global unzip "C:\Program Files\7-Zip\7z"				      					// Location of 7z executable program
global loc "CHANGE TO RELEVANT DRIVE"											// CHANGE DRIVE WHERE FORLDERS ARE LOCATED
global dta_dsc "$loc\firm_description\dta"										// Location of firm description output data										
global dta_fin "$loc\financials\dta"											// Location of financialss output data
global dta_own "$loc\ownership\dta"												// Location of ownership output data

* 1) Process address file
*** Obtain unique ISO codes in each DTA file
clear
fs "$dta_dsc\intermediate\*.dta"
	return list
set obs 1 
	gen fn = ""
	gen id = 0
foreach f in `r(files)' {
	insobs 1
	replace id = id[_n-1] + 1 if _n > 1
	local name `f'
	replace fn = "`name'" if _n == _N
}
drop if id == 0
keep if strpos(fn,"address") > 0
split fn, p(".") gen(fname)
	keep fname1 id
	rename fname1 fname
	gen string = substr(fname,-2,2)
	keep id string
		drop id
		gen id = _n
	 disp "List of files in processing loop"
save "$loc\firm_description\process.dta", replace
	qui sum id
	return list
forval i = `r(min)'(1)`r(max)' {
	use "$loc\firm_description\process.dta", clear
	noisily keep if id == `i'
	global st `=string[1]'	
	disp "$st"	
	use "$dta\intermediate\all addresses00$st.txt.dta", clear
		keep countryisocode
		drop if strlen(countryisocode) != 2
		rename countryisocode country
		bys country: keep if _n == 1
	save "$dta\intermediate\ISO00$st.dta", replace
}

erase "$loc\firm_description\process.dta"

*** Stack these files
clear
fs "$dta_dsc\intermediate\*.dta"
	return list
set obs 1 
	gen fn = ""
	gen id = 0
foreach f in `r(files)' {
	insobs 1
	replace id = id[_n-1] + 1 if _n > 1
	local name `f'
	replace fn = "`name'" if _n == _N
}
drop if id == 0
keep if strpos(fn,"ISO") > 0
split fn, p(".") gen(fname)
	keep fname1 id
	rename fname1 fname
	gen string = substr(fname,-2,2)
	keep id string
		drop id
		gen id = _n
	 disp "List of files in processing loop"
save "$loc\firm_description\iso_files.dta", replace
	qui sum id
	return list
	
use "$loc\firm_description\iso_files.dta", clear
	keep if id == 1
	global st `=string[1]'
	disp "$st"
	use "$dta\intermediate\ISO00$st.dta", clear		
save "$loc\countries_ISO.dta", replace
erase "$dta\intermediate\ISO00$st.dta"

use "$loc\firm_description\iso_files.dta", clear
	sum id
forval i = 2(1)`r(max)'{
	clear
	use "$loc\firm_description\iso_files.dta", clear
	keep if id == `i'
	global st `=string[1]'	
	disp "$st"
	use "$dta\intermediate\ISO00$st.dta", clear	
		append using "$loc\countries_ISO.dta"
	save "$loc\countries_ISO.dta", replace
	erase "$dta\intermediate\ISO00$st.dta"
}
duplicates drop																	
save "$loc\countries_ISO.dta", replace

* 2) Combine with the Entity data
use "$dta_own\intermediate\entities.dta", clear
	keep countryisocode
	drop if strlen(countryisocode) != 2
	rename countryisocode country
	bys country: keep if _n == 1
append using "$loc\countries_ISO.dta"
	duplicates drop
save "$loc\countries_ISO.dta", replace
